﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace Server
{
    // NOTE: If you change the class name "MyService" here, you must also update the reference to "MyService" in App.config.
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
    //[ServiceBehavior(InstanceContextMode = InstanceContextMode.PerSession)]
    //[ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
    public class MyService : IMyService, IDisposable
    {
        // 函数在同一实例中被调用的次数
        int callCount;
        // 服务实例的个数
        int instance = 0;

        // 构造函数，初始化callCount，并将服务实例的个数加1
        public MyService()
        {
            callCount = 0;
            instance++;
            Console.WriteLine("Create a new instance: [" + instance.ToString() + "]");
        }

        // 被调用的函数，每次被调用callCount加1
        public void MyMethod()
        {
            callCount++;
            string OutStr = "instrance [" + instance.ToString() + "]: the [" + callCount.ToString() + "] time(s) to call mymethod!";
            Console.WriteLine(OutStr);
        }

        // 销毁实例的函数，实例个数减1
        public void Dispose()
        {
            Console.WriteLine("Dispose the instance [" + instance.ToString() + "]");
            instance--;
            Console.WriteLine();
        }
    }
}
